Index: trunk/sources/HeuristicLab.Core/3.2/ChooseItemDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/ChooseItemDialog.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/ChooseItemDialog.cs	(revision 2591)
@@ -89,11 +89,9 @@
       }
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      foreach (PluginInfo plugin in discoveryService.Plugins) {
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginNode = new TreeNode(plugin.Name);
         pluginNode.Tag = null;
 
-        Type[] types = discoveryService.GetTypes(itemType, plugin);
-        foreach (Type type in types) {
+        foreach (Type type in ApplicationManager.Manager.GetTypes(itemType, plugin)) {
           if (!type.IsAbstract) {
             TreeNode itemNode = new TreeNode();
Index: trunk/sources/HeuristicLab.Core/3.2/ChooseOperatorDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/ChooseOperatorDialog.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/ChooseOperatorDialog.cs	(revision 2591)
@@ -70,14 +70,12 @@
       builtinOperatorsTreeView.TreeViewNodeSorter = nodeSorter;
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      PluginInfo[] plugins = discoveryService.Plugins;
-      foreach(PluginInfo plugin in plugins) {
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginItem = new TreeNode();
         pluginItem.Text = plugin.Name;
         pluginItem.Tag = plugin;
 
-        Type[] operators = discoveryService.GetTypes(typeof(IOperator), plugin);
-        foreach(Type type in operators) {
-          if(!type.IsAbstract) {
+        IEnumerable<Type> operators = ApplicationManager.Manager.GetTypes(typeof(IOperator), plugin);
+        foreach (Type type in operators) {
+          if (!type.IsAbstract) {
             TreeNode operatorItem = new TreeNode();
             operatorItem.Text = type.Name;
@@ -87,5 +85,5 @@
         }
         // add plugin node only if it contains operators
-        if(pluginItem.Nodes.Count > 0) {
+        if (pluginItem.Nodes.Count > 0) {
           builtinOperatorsTreeView.Nodes.Add(pluginItem);
         }
Index: trunk/sources/HeuristicLab.Core/3.2/ChooseTypeDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/ChooseTypeDialog.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/ChooseTypeDialog.cs	(revision 2591)
@@ -90,11 +90,9 @@
       }
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      foreach (PluginInfo plugin in discoveryService.Plugins) {
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginNode = new TreeNode(plugin.Name);
         pluginNode.Tag = null;
 
-        Type[] types = discoveryService.GetTypes(baseType, plugin);
-        foreach (Type type in types) {
+        foreach (Type type in ApplicationManager.Manager.GetTypes(baseType, plugin)) {
           TreeNode itemNode = new TreeNode();
           itemNode.Text = type.Name;
Index: trunk/sources/HeuristicLab.Core/3.2/HeuristicLabCorePlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/HeuristicLabCorePlugin.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/HeuristicLabCorePlugin.cs	(revision 2591)
@@ -30,7 +30,7 @@
   /// Plugin class for HeuristicLab.Core plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Core-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Core-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Common-3.2")]
+  [Plugin("HeuristicLab.Core-3.2")]
+  [PluginFile("HeuristicLab.Core-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common-3.2")]
   public class HeuristicLabCorePlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Core/3.2/Interfaces/IView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/Interfaces/IView.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/Interfaces/IView.cs	(revision 2591)
@@ -29,5 +29,5 @@
   /// An interface for all kinds visual representations of items (objects, operators...).
   /// </summary>
-  public interface IView : IControl {
+  public interface IView {
     /// <summary>
     /// Gets the current item instance.
Index: trunk/sources/HeuristicLab.Core/3.2/OperatorGraphView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/OperatorGraphView.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/OperatorGraphView.cs	(revision 2591)
@@ -184,5 +184,5 @@
         IView view = op.CreateView();
         if (view != null)
-          PluginManager.ControlManager.ShowControl(view);
+          ControlManager.Manager.ShowControl(view);
       }
     }
@@ -411,5 +411,5 @@
     private void viewToolStripMenuItem_Click(object sender, EventArgs e) {
       IView view = (IView)((ToolStripMenuItem)sender).Tag;
-      PluginManager.ControlManager.ShowControl(view);
+      ControlManager.Manager.ShowControl(view);
     }
     private void initialOperatorToolStripMenuItem_Click(object sender, EventArgs e) {
Index: trunk/sources/HeuristicLab.Core/3.2/OperatorLibraryEditor.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/OperatorLibraryEditor.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/OperatorLibraryEditor.cs	(revision 2591)
@@ -204,5 +204,5 @@
           IView view = op.CreateView();
           if (view != null)
-            PluginManager.ControlManager.ShowControl(view);
+            ControlManager.Manager.ShowControl(view);
         }
       }
@@ -287,5 +287,5 @@
     private void viewToolStripMenuItem_Click(object sender, EventArgs e) {
       IView view = (IView)viewToolStripMenuItem.Tag;
-      PluginManager.ControlManager.ShowControl(view);
+      ControlManager.Manager.ShowControl(view);
     }
     #endregion
Index: trunk/sources/HeuristicLab.Core/3.2/ScopeView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.2/ScopeView.cs	(revision 2474)
+++ trunk/sources/HeuristicLab.Core/3.2/ScopeView.cs	(revision 2591)
@@ -131,5 +131,5 @@
       if(scopesTreeView.SelectedNode != null && scopesTreeView.SelectedNode.Tag != null) {
         IScope scope = (IScope)scopesTreeView.SelectedNode.Tag;
-        PluginManager.ControlManager.ShowControl(new VariablesScopeView(scope));
+        ControlManager.Manager.ShowControl(new VariablesScopeView(scope));
       }
     }
@@ -199,9 +199,9 @@
     private void variablesToolStripMenuItem_Click(object sender, EventArgs e) {
       IScope scope = (IScope)scopesTreeView.SelectedNode.Tag;
-      PluginManager.ControlManager.ShowControl(new VariablesScopeView(scope));
+      ControlManager.Manager.ShowControl(new VariablesScopeView(scope));
     }
     private void showViewToolStripMenuItem_Click(object sender, EventArgs e) {
       IItem item = (IItem)((ToolStripMenuItem)sender).Tag;
-      PluginManager.ControlManager.ShowControl(item.CreateView());
+      ControlManager.Manager.ShowControl(item.CreateView());
     }
     #endregion