Index: trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2593)
+++ trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2596)
@@ -1,3 +1,2 @@
-copy "%SolutionDir%\HeuristicLab.PluginInfrastructure.GUI\ICSharpCode.SharpZipLib License.txt" .\
 
 copy "%SolutionDir%\ALGLIB\%Outdir%\ALGLIB.dll" .\
Index: trunk/sources/HeuristicLab/CustomPostBuildTemplate_UpdateLocalInstallation.cmd
===================================================================
--- trunk/sources/HeuristicLab/CustomPostBuildTemplate_UpdateLocalInstallation.cmd	(revision 2593)
+++ trunk/sources/HeuristicLab/CustomPostBuildTemplate_UpdateLocalInstallation.cmd	(revision 2596)
@@ -1,8 +1,117 @@
 set target=C:\Program Files\HeuristicLab 3.0
 
-copy * "%target%"
-REM copy "HeuristicLab.exe.config" "%target%"
-REM copy "HeuristicLab.PluginInfrastructure.dll" "%target%"
-REM copy "HeuristicLab.PluginInfrastructure.GUI.dll" "%target%"
-REM copy "ICSharpCode.SharpZipLib.dll" "%target%"
-REM copy "ICSharpCode.SharpZipLib License.txt" "%target%"
+copy "HeuristicLab.exe.config" "%target%"
+copy "HeuristicLab.PluginInfrastructure.dll" "%target%"
+
+copy "ALGLIB.dll" "%target%"
+copy "ALGLIB License.txt" "%target%"
+copy "HeuristicLab.AdvancedOptimizationFrontend-3.2.dll" "%target%"
+copy "HeuristicLab.ArtificialNeuralNetworks-3.2.dll" "%target%"
+copy "HeuristicLab.Assignment.QAP-3.2.dll" "%target%"
+copy "HeuristicLab.BitVector-3.2.dll" "%target%"
+copy "HeuristicLab.BackgroundProcessing-3.2.dll" "%target%"
+copy "HeuristicLab.CEDMA.Server-3.3.dll" "%target%"
+copy "HeuristicLab.Charting-3.2.dll" "%target%"
+copy "HeuristicLab.Charting.Data-3.2.dll" "%target%"
+copy "HeuristicLab.Common-3.2.dll" "%target%" 
+copy "HeuristicLab.Common.Resources-3.2.dll" "%target%"
+copy "HeuristicLab.Communication.Data-3.2.dll" "%target%"
+copy "HeuristicLab.Communication.Operators-3.2.dll" "%target%"
+copy "HeuristicLab.Core-3.2.dll" "%target%"
+copy "HeuristicLab.Constraints-3.2.dll" "%target%"
+copy "HeuristicLab.Data-3.2.dll" "%target%"
+copy "HeuristicLab.DataAccess-3.2.dll" "%target%"
+copy "HeuristicLab.DataAccess.ADOHelper-3.2.dll" "%target%"
+copy "HeuristicLab.DataAnalysis-3.2.dll" "%target%"
+copy "HeuristicLab.DistributedEngine-3.2.dll" "%target%"
+copy "HeuristicLab.ES-3.2.dll" "%target%"
+copy "HeuristicLab.Evolutionary-3.2.dll" "%target%"
+copy "HeuristicLab.GP-3.3.dll" "%target%"
+copy "HeuristicLab.GP.Algorithms-3.2.dll" "%target%"
+copy "HeuristicLab.GP.Interfaces-3.3.dll" "%target%"
+copy "HeuristicLab.GP.Operators-3.3.dll" "%target%"
+copy "HeuristicLab.GP.Boolean-3.3.dll" "%target%"
+copy "HeuristicLab.GP.SantaFe-3.3.dll" "%target%"
+copy "HeuristicLab.GP.StructureIdentification-3.3.dll" "%target%"
+copy "HeuristicLab.GP.StructureIdentification.Classification-3.3.dll" "%target%"
+copy "HeuristicLab.GP.StructureIdentification.ConditionalEvaluation-3.3.dll" "%target%"
+copy "HeuristicLab.GP.StructureIdentification.TimeSeries-3.3.dll" "%target%"
+copy "HeuristicLab.Grid-3.2.dll" "%target%"
+copy "HeuristicLab.Grid.HiveBridge-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Client.Common-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Client.Communication-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Client.Console-3.2.dll" "%target%"
+copy "ZedGraph.dll" "%target%"
+copy "Calendar.DayView.dll" "%target%"
+copy "HeuristicLab.Hive.Client.Core-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Client.ExecutionEngine-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Engine-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.JobBase-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Server-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Server.ADODataAccess-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Server.Console-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Server.Core-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Contracts-3.2.dll" "%target%"
+copy "Authorization\*.xml" "%target%"
+copy "HeuristicLab.Hive.Server.DataAccess-3.2.dll" "%target%"
+copy "HeuristicLab.Hive.Server.Scheduler-3.2.dll" "%target%"
+copy "HeuristicLab.IntVector-3.2.dll" "%target%"
+copy "HeuristicLab.LinearRegression-3.2.dll" "%target%"
+copy "HeuristicLab.Logging-3.2.dll" "%target%"
+copy "HeuristicLab.MainForm-3.2.dll" "%target%"
+copy "HeuristicLab.MainForm.Test-3.2.dll" "%target%"
+copy "HeuristicLab.MainForm.WindowsForms-3.2.dll" "%target%"
+copy "WeifenLuo.WinFormsUI.Docking.dll" "%target%"
+copy "WeifenLuo.WinFormsUI.Docking License.txt" "%target%"
+copy "HeuristicLab.Modeling-3.2.dll" "%target%"
+copy "HeuristicLab.Modeling.Database-3.2.dll" "%target%"
+copy "HeuristicLab.Modeling.Database.SQLServerCompact-3.2.dll" "%target%"
+copy "HeuristicLab.Operators-3.2.dll" "%target%"
+copy "HeuristicLab.Operators.Metaprogramming-3.2.dll" "%target%"
+copy "HeuristicLab.Operators.Programmable-3.2.dll" "%target%"
+copy "HeuristicLab.Operators.Stopwatch-3.2.dll" "%target%"
+copy "HeuristicLab.OptimizationFrontend-3.2.dll" "%target%"
+copy "HeuristicLab.Permutation-3.2.dll" "%target%"
+copy "HeuristicLab.Random-3.2.dll" "%target%"
+copy "HeuristicLab.RealVector-3.2.dll" "%target%"
+copy "HeuristicLab.Routing.TSP-3.2.dll" "%target%"
+copy "HeuristicLab.SA-3.2.dll" "%target%"
+copy "HeuristicLab.Scheduling.JSSP-3.2.dll" "%target%"
+copy "HeuristicLab.Selection-3.2.dll" "%target%"
+copy "HeuristicLab.Selection.OffspringSelection-3.2.dll" "%target%"
+copy "HeuristicLab.Selection.Uncertainty-3.2.dll" "%target%"
+copy "HeuristicLab.SequentialEngine-3.2.dll" "%target%"
+copy "HeuristicLab.SGA-3.2.dll" "%target%"
+copy "HeuristicLab.FixedOperators-3.2.dll" "%target%"
+copy "HeuristicLab.SimOpt-3.2.dll" "%target%"
+copy "HeuristicLab.SQLite-3.2.dll" "%target%"
+copy "SQLite License.txt" "%target%"
+copy "SQLite.NET.chm" "%target%"
+copy "HeuristicLab.SQLServerCompact-3.2.dll" "%target%"
+copy "System.Data.SqlServerCe.dll" "%target%"
+copy "sqlceca35.dll" "%target%"
+copy "sqlcecompact35.dll" "%target%"
+copy "sqlceer35EN.dll" "%target%"
+copy "sqlceme35.dll" "%target%"
+copy "sqlceoledb35.dll" "%target%"
+copy "sqlceqp35.dll" "%target%"
+copy "sqlcese35.dll" "%target%"
+copy "HeuristicLab.StatisticalAnalysis-3.2.dll" "%target%"
+copy "HeuristicLab.SupportVectorMachines-3.2.dll" "%target%"
+copy "LibSVM.dll" "%target%"
+copy "HeuristicLab.TestFunctions-3.2.dll" "%target%"
+copy "HeuristicLab.ThreadParallelEngine-3.2.dll" "%target%"
+copy "HeuristicLab.Tracing-3.2.dll" "%target%"
+copy "log4net.dll" "%target%"
+copy "log4net licence.txt" "%target%"
+copy "HeuristicLab.log4net.xml" "%target%"
+copy "HeuristicLab.Hive.log4net.xml" "%target%"
+copy "HeuristicLab.Visualization-3.2.dll" "%target%"
+copy "HeuristicLab.Visualization.Test-3.2.dll" "%target%"
+copy "HeuristicLab.Security.Contracts-3.2.dll" "%target%"
+copy "HeuristicLab.Security.Core-3.2.dll" "%target%"
+copy "HeuristicLab.Security.DataAccess-3.2.dll" "%target%"
+copy "HeuristicLab.Security.ADODataAccess-3.2.dll" "%target%"
+copy "HeuristicLab.Security.Server-3.2.dll" "%target%"
+copy "System.Data.SQLite.dll" "%target%"
+
Index: trunk/sources/HeuristicLab/MergeConfigs.cmd
===================================================================
--- trunk/sources/HeuristicLab/MergeConfigs.cmd	(revision 2593)
+++ trunk/sources/HeuristicLab/MergeConfigs.cmd	(revision 2596)
@@ -1,4 +1,3 @@
 ConfigMerger "%SolutionDir%\HeuristicLab.PluginInfrastructure\%Outdir%\HeuristicLab.PluginInfrastructure.dll.config" "HeuristicLab.exe.config"
-ConfigMerger "%SolutionDir%\HeuristicLab.PluginInfrastructure.GUI\%Outdir%\HeuristicLab.PluginInfrastructure.GUI.dll.config" "HeuristicLab.exe.config"
 ConfigMerger "%SolutionDir%\HeuristicLab.Hive.Client.Core\3.2\%Outdir%\HeuristicLab.Hive.Client.Core-3.2.dll.config" "HeuristicLab.exe.config"
 ConfigMerger "%SolutionDir%\HeuristicLab.Hive.Client.Console\3.2\%Outdir%\HeuristicLab.Hive.Client.Console-3.2.dll.config" "HeuristicLab.exe.config"