Index: trunk/sources/HeuristicLab 3.2.sln
===================================================================
--- trunk/sources/HeuristicLab 3.2.sln	(revision 2604)
+++ trunk/sources/HeuristicLab 3.2.sln	(revision 2605)
@@ -12,4 +12,98 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab", "HeuristicLab\HeuristicLab.csproj", "{623FB817-8371-4A9A-A491-4DECC87B2BBB}"
+	ProjectSection(ProjectDependencies) = postProject
+		{7C20D100-8BEB-433A-9499-F075E2CB9297} = {7C20D100-8BEB-433A-9499-F075E2CB9297}
+		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC} = {569E430B-B4CE-4B94-A44E-6246B6E4E3BC}
+		{6E757D0E-20F9-4E89-AF06-D7DA256870DB} = {6E757D0E-20F9-4E89-AF06-D7DA256870DB}
+		{AEB51212-CDBA-4FC6-A2EE-02359AA53ECE} = {AEB51212-CDBA-4FC6-A2EE-02359AA53ECE}
+		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84} = {4D5A2A16-66C2-431D-9AA3-BD3041E64B84}
+		{E84E5717-79F8-498F-A5E0-A055C4EC086B} = {E84E5717-79F8-498F-A5E0-A055C4EC086B}
+		{F05D261A-4F7D-46C9-AB9C-21FD4566D719} = {F05D261A-4F7D-46C9-AB9C-21FD4566D719}
+		{21187322-52DD-4243-80A4-A85F0263E63B} = {21187322-52DD-4243-80A4-A85F0263E63B}
+		{A04AE929-D0E1-466D-A9D3-BF3C4B2C209F} = {A04AE929-D0E1-466D-A9D3-BF3C4B2C209F}
+		{C2FB432A-07CA-45B5-BAFE-FEC172D1107B} = {C2FB432A-07CA-45B5-BAFE-FEC172D1107B}
+		{D59E852C-F205-4647-8C05-EB9ED1CF44E9} = {D59E852C-F205-4647-8C05-EB9ED1CF44E9}
+		{4095C92C-5A4C-44BC-9963-5F384CF5CC3F} = {4095C92C-5A4C-44BC-9963-5F384CF5CC3F}
+		{9A781B2F-A58D-4270-A28A-3B14BBC11F4A} = {9A781B2F-A58D-4270-A28A-3B14BBC11F4A}
+		{E0740131-AA3E-4A3F-BA03-C9FF8327F4EE} = {E0740131-AA3E-4A3F-BA03-C9FF8327F4EE}
+		{74223A32-C726-4978-BE78-37113A18373C} = {74223A32-C726-4978-BE78-37113A18373C}
+		{23117533-8A91-474E-BBF6-C39485D0810A} = {23117533-8A91-474E-BBF6-C39485D0810A}
+		{715A9134-B6E4-4CB9-8A5A-E6601497565A} = {715A9134-B6E4-4CB9-8A5A-E6601497565A}
+		{44456535-5DB5-454A-BE2B-7426DA6700B6} = {44456535-5DB5-454A-BE2B-7426DA6700B6}
+		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1} = {0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}
+		{67A6B73B-6FC3-4DB8-8FC1-D4C55A4918C5} = {67A6B73B-6FC3-4DB8-8FC1-D4C55A4918C5}
+		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C} = {CE2DFB48-6A9C-4507-96C6-5FC40E92035C}
+		{9EF75B49-D507-44E0-BC5D-C200FDA53B9B} = {9EF75B49-D507-44E0-BC5D-C200FDA53B9B}
+		{E3288D4B-7A51-499A-AC5B-019319CE51DC} = {E3288D4B-7A51-499A-AC5B-019319CE51DC}
+		{32DAA44F-944A-465F-A5C9-1C491EE4976D} = {32DAA44F-944A-465F-A5C9-1C491EE4976D}
+		{1DAA4952-8D6B-4D43-A9E5-5466053DA777} = {1DAA4952-8D6B-4D43-A9E5-5466053DA777}
+		{89F4BC52-C174-481E-9BD2-3814171020E8} = {89F4BC52-C174-481E-9BD2-3814171020E8}
+		{F5614C53-153C-4A37-A608-121E1C087F07} = {F5614C53-153C-4A37-A608-121E1C087F07}
+		{B4BE8E53-BA06-4237-9A01-24255F880201} = {B4BE8E53-BA06-4237-9A01-24255F880201}
+		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B} = {5CDACE54-5FB2-4344-A21C-963F63CB7C2B}
+		{F18FD554-19B9-460C-9A49-4AA8D7245727} = {F18FD554-19B9-460C-9A49-4AA8D7245727}
+		{EC1AA756-D612-4FA6-AA52-25CF4F8E3836} = {EC1AA756-D612-4FA6-AA52-25CF4F8E3836}
+		{545CE756-98D8-423B-AC2E-6E7D70926E5C} = {545CE756-98D8-423B-AC2E-6E7D70926E5C}
+		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A} = {3BD61258-31DA-4B09-89C0-4F71FEF5F05A}
+		{7E18E25A-BCEB-467A-BACC-ABCA73F9D655} = {7E18E25A-BCEB-467A-BACC-ABCA73F9D655}
+		{8B14A35E-DBDF-43EB-B019-23E9FBC5A35E} = {8B14A35E-DBDF-43EB-B019-23E9FBC5A35E}
+		{39DEF061-8261-43DB-8B3B-C7555251FF77} = {39DEF061-8261-43DB-8B3B-C7555251FF77}
+		{2D4E4565-3ED9-4BEB-AE75-39D871843D24} = {2D4E4565-3ED9-4BEB-AE75-39D871843D24}
+		{1605256A-1CB3-44AB-AAFF-577093EE5789} = {1605256A-1CB3-44AB-AAFF-577093EE5789}
+		{FCD62C6F-4793-4593-AE9A-0BDCA256EE99} = {FCD62C6F-4793-4593-AE9A-0BDCA256EE99}
+		{F7CF0571-25CB-43D5-8443-0843A1E2861A} = {F7CF0571-25CB-43D5-8443-0843A1E2861A}
+		{47019A74-F7F7-482E-83AA-D3F4F777E879} = {47019A74-F7F7-482E-83AA-D3F4F777E879}
+		{B9A64475-D542-47CF-9688-735F6224F055} = {B9A64475-D542-47CF-9688-735F6224F055}
+		{42A1D075-6C12-4DD9-B0C2-C6F5210A8119} = {42A1D075-6C12-4DD9-B0C2-C6F5210A8119}
+		{A0821479-801F-43DF-B788-AE92FB410DA9} = {A0821479-801F-43DF-B788-AE92FB410DA9}
+		{679E977A-117B-456E-8594-2A4DEADB658B} = {679E977A-117B-456E-8594-2A4DEADB658B}
+		{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2} = {7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}
+		{9076697B-C151-46CD-95BC-1D059492B478} = {9076697B-C151-46CD-95BC-1D059492B478}
+		{4744FB81-7F42-4BBA-813E-68CAB6FE07E2} = {4744FB81-7F42-4BBA-813E-68CAB6FE07E2}
+		{4C0EF782-CC94-4A94-BC3E-661D2600559B} = {4C0EF782-CC94-4A94-BC3E-661D2600559B}
+		{6AEF1284-2428-4B01-B9D2-62C1FA7C2DE1} = {6AEF1284-2428-4B01-B9D2-62C1FA7C2DE1}
+		{31DD6385-7276-49ED-9533-823D4CDF3D2A} = {31DD6385-7276-49ED-9533-823D4CDF3D2A}
+		{5010BD86-23B7-4F8C-888A-76D21AD5266A} = {5010BD86-23B7-4F8C-888A-76D21AD5266A}
+		{E39AF78A-9692-472B-B061-E2F1B1AB2C92} = {E39AF78A-9692-472B-B061-E2F1B1AB2C92}
+		{1F5FA590-1D2D-406C-BDBD-03BAECEA3C80} = {1F5FA590-1D2D-406C-BDBD-03BAECEA3C80}
+		{6EDEE199-61FC-48E1-AEDA-AF1C2E722063} = {6EDEE199-61FC-48E1-AEDA-AF1C2E722063}
+		{3127719F-110E-4558-8845-98559DBB422D} = {3127719F-110E-4558-8845-98559DBB422D}
+		{A9983BA2-B3B2-475E-8E2C-62050B71D1C5} = {A9983BA2-B3B2-475E-8E2C-62050B71D1C5}
+		{2E6112A7-3A94-406D-A28C-38AC2D324DCA} = {2E6112A7-3A94-406D-A28C-38AC2D324DCA}
+		{E66D1EAA-525C-4F6D-BD25-DBCAE3750E25} = {E66D1EAA-525C-4F6D-BD25-DBCAE3750E25}
+		{F43B59AB-2B8C-4570-BC1E-15592086517C} = {F43B59AB-2B8C-4570-BC1E-15592086517C}
+		{589BECAE-69B0-4EB1-8C06-C073531762B7} = {589BECAE-69B0-4EB1-8C06-C073531762B7}
+		{F473D9AF-3F09-4296-9F28-3C65118DAFFA} = {F473D9AF-3F09-4296-9F28-3C65118DAFFA}
+		{55FDCFB3-3E8C-4FB0-837C-0CF06BEDED39} = {55FDCFB3-3E8C-4FB0-837C-0CF06BEDED39}
+		{A16F23B5-FB62-499E-A831-26953AA56FE2} = {A16F23B5-FB62-499E-A831-26953AA56FE2}
+		{6084CFB5-733F-449D-9F92-2E40D13F0514} = {6084CFB5-733F-449D-9F92-2E40D13F0514}
+		{F0F97CBA-61A2-471C-9973-F099202B3BE5} = {F0F97CBA-61A2-471C-9973-F099202B3BE5}
+		{6D9564BB-956D-4808-8F92-AA7F776F90A5} = {6D9564BB-956D-4808-8F92-AA7F776F90A5}
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A} = {45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}
+		{AB687BBE-1BFE-476B-906D-44237135431D} = {AB687BBE-1BFE-476B-906D-44237135431D}
+		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11} = {C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}
+		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F} = {FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}
+		{C75532C4-765B-418E-B09B-46D36B2ABDB1} = {C75532C4-765B-418E-B09B-46D36B2ABDB1}
+		{85FA46C6-761E-4098-9EF7-060ECC386396} = {85FA46C6-761E-4098-9EF7-060ECC386396}
+		{E3CCBFC6-900C-41B6-AFB8-6646DB097435} = {E3CCBFC6-900C-41B6-AFB8-6646DB097435}
+		{B462D3CC-8866-42F0-9832-AD0967613B72} = {B462D3CC-8866-42F0-9832-AD0967613B72}
+		{74752FCD-9E10-48DB-9AF2-AF5518B62807} = {74752FCD-9E10-48DB-9AF2-AF5518B62807}
+		{6960CBCD-E44B-49B0-BA86-671091C42C36} = {6960CBCD-E44B-49B0-BA86-671091C42C36}
+		{898B31CF-81DC-453B-AEB3-BDF83197A7EE} = {898B31CF-81DC-453B-AEB3-BDF83197A7EE}
+		{205898D3-2717-4686-AF17-52409B7EC0C6} = {205898D3-2717-4686-AF17-52409B7EC0C6}
+		{134F93D7-E7C8-4ECD-9923-7F63259A60D8} = {134F93D7-E7C8-4ECD-9923-7F63259A60D8}
+		{EE2034D9-6E27-48A1-B855-42D45F69A4FC} = {EE2034D9-6E27-48A1-B855-42D45F69A4FC}
+		{80F7FADA-549D-4151-8856-79B620A50DBA} = {80F7FADA-549D-4151-8856-79B620A50DBA}
+		{ABAE70E0-14E3-4588-B6BB-15DF022985C3} = {ABAE70E0-14E3-4588-B6BB-15DF022985C3}
+		{583705E2-B1F7-42B8-8149-96E7AECA171A} = {583705E2-B1F7-42B8-8149-96E7AECA171A}
+		{E392A1E2-DC95-4E33-B82E-8ED690EDA1AB} = {E392A1E2-DC95-4E33-B82E-8ED690EDA1AB}
+		{14E1C3E3-2496-436A-AE00-09F7B81DB15B} = {14E1C3E3-2496-436A-AE00-09F7B81DB15B}
+		{DFAC1BEA-6D9D-477F-AC7B-E64977644DDB} = {DFAC1BEA-6D9D-477F-AC7B-E64977644DDB}
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC} = {924B6BEA-9A99-40FE-9334-5C01E8D540EC}
+		{1F1CF3ED-374C-4288-995B-93F6B872F571} = {1F1CF3ED-374C-4288-995B-93F6B872F571}
+		{0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21} = {0AFC3DEE-0CA4-4CE6-BDE2-E06DDBB8BD21}
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4} = {1FC004FC-59AF-4249-B1B6-FF25873A20E4}
+		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C} = {AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}
+	EndProjectSection
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.PluginInfrastructure", "HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj", "{94186A6A-5176-4402-AE83-886557B53CCA}"